Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.ui.forms.widgets
Class ColumnLayout

    java.lang.Object
      org.eclipse.swt.widgets.Layout
          org.eclipse.ui.forms.widgets.ColumnLayout

All Implemented Interfaces:
  ILayoutExtension

public final class ColumnLayout
extends Layout
implements ILayoutExtension

This layout manager arranges children of the composite parent in vertical columns. All the columns are identical size and children are stretched horizontally to fill the column width. The goal is to give layout some reasonable range of column numbers to allow it to handle various parent widths. That way, column number will drop to the lowest number in the range when width decreases, and grow up to the highest number in the range when allowed by the parent width.

In addition, the layout attempts to 'fill the space' equally i.e. to avoid large gaps at the and of the last column.

Child controls are layed out according to their 'natural' (preferred) size. For 'stretchy' controls that do not have natural preferred size, it is possible to set width and/or height hints using ColumnLayoutData objects.

Since:
  3.0
See Also:
  `ColumnLayoutData`

Field Summary
`int` | `bottomMargin` Bottom margin (default is 5).
`int` | `horizontalSpacing` Horizontal spacing between columns (default is 5).
`int` | `leftMargin` Left margin (default is 5).
`int` | `maxNumColumns` Maximum number of columns (default is 3).
`int` | `minNumColumns` Minimum number of columns (default is 1).
`int` | `rightMargin` Right margin (default is 5).
`int` | `topMargin` Top margin (default is 5).
`int` | `verticalSpacing` Vertical spacing between controls (default is 5).

Constructor Summary
`ColumnLayout()` Creates a new instance of the column layout.

Method Summary
`int` | `computeMaximumWidth(Composite parent, boolean changed)` Computes the maximum width of the parent.
`int` | `computeMinimumWidth(Composite parent, boolean changed)` Computes the minimum width of the parent.
`protected Point` | `computeSize(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected void` | `layout(Composite parent, boolean flushCache)` Lays out the children of the specified composite according to this layout.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### minNumColumns

    public int minNumColumns

  Minimum number of columns (default is 1).

### maxNumColumns

    public int maxNumColumns

  Maximum number of columns (default is 3).

### horizontalSpacing

    public int horizontalSpacing

  Horizontal spacing between columns (default is 5).

### verticalSpacing

    public int verticalSpacing

  Vertical spacing between controls (default is 5).

### topMargin

    public int topMargin

  Top margin (default is 5).

### leftMargin

    public int leftMargin

  Left margin (default is 5).

### bottomMargin

    public int bottomMargin

  Bottom margin (default is 5).

### rightMargin

    public int rightMargin

  Right margin (default is 5).

Constructor Detail

### ColumnLayout

    public ColumnLayout()

  Creates a new instance of the column layout.

Method Detail

### computeSize

    protected Point computeSize(Composite composite,
                                int wHint,
                                int hHint,
                                boolean flushCache)

  Description copied from class: `Layout`
  Computes and returns the size of the specified composite's client area according to this layout.

  This method computes the minimum size that the client area of the composite must be in order to position all children at their minimum size inside the composite according to the layout algorithm encoded by this layout.

  When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the minimum width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

  Specified by:
    `computeSize` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `wHint` - width (`SWT.DEFAULT` for minimum)
    `hHint` - height (`SWT.DEFAULT` for minimum)
    `flushCache` - `true` means flush cached layout values
  Returns:
    a point containing the computed size (width, height)
  See Also:
    `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack()`, "computeTrim, getClientArea for controls that implement them"

### layout

    protected void layout(Composite parent,
                          boolean flushCache)

  Description copied from class: `Layout`
  Lays out the children of the specified composite according to this layout.

  This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

  When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is layed out.

  When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

  Specified by:
    `layout` in class `Layout`
  Parameters:
    `parent` - a composite widget using this layout
    `flushCache` - `true` means flush cached layout values

### computeMaximumWidth

    public int computeMaximumWidth(Composite parent,
                                   boolean changed)

  Description copied from interface: `ILayoutExtension`
  Computes the maximum width of the parent. All widgets capable of word wrapping should return the length of the entire text with wrapping turned off.

  Specified by:
    `computeMaximumWidth` in interface `ILayoutExtension`
  Parameters:
    `parent` - the parent composite
    `changed` - `true` if the cached information should be flushed, `false` otherwise.
  Returns:
    the maximum width of the parent composite

### computeMinimumWidth

    public int computeMinimumWidth(Composite parent,
                                   boolean changed)

  Description copied from interface: `ILayoutExtension`
  Computes the minimum width of the parent. All widgets capable of word wrapping should return the width of the longest word that cannot be broken any further.

  Specified by:
    `computeMinimumWidth` in interface `ILayoutExtension`
  Parameters:
    `parent` - the parent composite
    `changed` - `true` if the cached information should be flushed, `false` otherwise.
  Returns:
    the minimum width of the parent composite

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.